/*

Processing 3.0b2

This is a quick and dirty sketch to extract data from hacked 
 necomimi, mindflex and focetrainer toys. 
 Simply connect the T of the neurosky module to the R 
 of a slave bluetooth module and connect.
 Note: 
 the Force Trainer and Mind Flex use 9600 Baud
 the Necomimi uses 57600 Baud and delivers additional RAW data.
 Your Bluetooth module should be configured as such.
 
 programmed by James G Watt September 2015. www.artronix.co.uk
 */

import processing.serial.*;

Serial serial;
Serial serial1;

int inByte;
int ByteCount;
int serialOutput;
String inString;  // Input string from serial port

int[] myArray = new int[38];
int[] necomimi = new int[14];

int xPlot; //xplot 0-100%
int update = 0;

int x;
int[] highvalue = new int[14]; //= 0;
int[] lowvalue = new int[14]; //= 65535;
float brainwave;

void setup() {
  // Set up serial connection
  println("Find your necomimi and arduino in the list below, note its [index]:\n");
  for (int i = 0; i < Serial.list ().length; i++) {
    println("[" + i + "] " + Serial.list()[i]);
  }

  // Put the index found above here:
  // serial in from Necomimi 57600 MindWave 9600 ForceTrainer 9600
  serial = new Serial(this, Serial.list()[0], 57600);    
  serial.bufferUntil(100);

// ARTRONIX serial out to arduino 9600
   serialOutput = 0; // set to 1 if you're attaching an arduino.
   if (serialOutput == 1){
   serial1 = new Serial(this, Serial.list()[0], 9600);    
   serial1.bufferUntil(64);
   }
   

  size(640, 480); // set width and height
//  size(1366, 768); // set width and height 
  background(0);
  noStroke();
  fill(102);
   
 strokeWeight(1);  // Default
 stroke(126);   
   
}

void draw() {


  
  if (update != necomimi[11]){
    
    for(x=3;x<11;x++){
    if (necomimi[x] > highvalue[x]){highvalue[x] = necomimi[x];}
    if (necomimi[x] < lowvalue[x]){lowvalue[x] = necomimi[x];}
    lowvalue[x] = lowvalue[x]++;
    highvalue[x] = highvalue[x]--;
    necomimi[x] = int (map (necomimi[x], highvalue[x], lowvalue[x], 100, 0));
    }
    
  stroke(#AAAAAA);  
  line(xPlot,(height/20),xPlot,(height/20)+  ((50-necomimi[1])*height)/2000);
  stroke(#808080);  
  line(xPlot,(height/20)*3,xPlot,((height/20)*3)+ ((50-necomimi[2])*height)/2000);
  
    stroke(#ff0000);  
  line(xPlot,(height/20)*6,xPlot,((height/20)*6)+ ((0-necomimi[3])*height)/2000);
  stroke(#00ff00);  
  line(xPlot,(height/20)*8,xPlot,((height/20)*8)+  ((0-necomimi[4])*height)/2000);
  
    stroke(#0000ff);  
  line(xPlot,(height/20)*10,xPlot,((height/20)*10)+  ((0-necomimi[5])*height)/2000);
  stroke(#00aaff);  
  line(xPlot,(height/20)*12,xPlot,((height/20)*12)+  ((0-necomimi[6])*height)/2000);
  
    stroke(#ffff00);  
  line(xPlot,(height/20)*14,xPlot,((height/20)*14)+ ((0-necomimi[7])*height)/2000);
  stroke(#aaff00);  
  line(xPlot,(height/20)*16,xPlot,((height/20)*16)+ ((0-necomimi[8])*height)/2000);
  
    stroke(#00ffff);  
  line(xPlot,(height/20)*18,xPlot,((height/20)*18)+ ((0-necomimi[9])*height)/2000);
  stroke(#ff00ff);  
  line(xPlot,(height/20)*20,xPlot,((height/20)*20)+ ((0-necomimi[10])*height)/2000);
  
  xPlot ++;
  if (xPlot == width){xPlot = 0; background(0);} 
  update = necomimi[11] ;
  }
  
    readheadset();
  
}

// look for brain data
void readheadset() {
  while (serial.available () > 32) {
    inByte = serial.read();
    if (inByte == 170) {
      inByte = serial.read();
      if (inByte == 170) {
        inByte = serial.read();
        if (inByte == 32) {
          necomimi();
        } else {
          if (inByte == 04) {
            necomimiRAW();
          }
        }
      }
    }
  }
}

// get the long packet values
void necomimi() {

  for (ByteCount = 3; ByteCount < 35; ByteCount ++  )  
  {
    inByte = serial.read();
    myArray[ByteCount] = inByte;
  }

  necomimi[0] = myArray[4] ; // signal strength 0-255. 0=good 200 = no contact.
  necomimi[1] = myArray[32] ; // Attention 0-100
  necomimi[2] = myArray[34] ; // Meditation 0-100
  necomimi[3] = (myArray[9]+(256*myArray[8])+(65536*myArray[7])); // delta (0.5 - 2.75Hz)
  necomimi[4] = (myArray[12]+(256*myArray[11])+(65536*myArray[10])); // theta (3.5 - 6.75Hz)
  necomimi[5] = (myArray[15]+(256*myArray[14])+(65536*myArray[13])); // low-alpha (7.5 - 9.25Hz)
  necomimi[6] = (myArray[18]+(256*myArray[17])+(65536*myArray[16])); // high-alpha (10 - 11.75Hz)
  necomimi[7] = (myArray[21]+(256*myArray[20])+(65536*myArray[19])); // low-beta (13 - 16.75Hz)
  necomimi[8] = (myArray[24]+(256*myArray[23])+(65536*myArray[22])); // high-beta (18 - 29.75Hz)
  necomimi[9] = (myArray[27]+(256*myArray[26])+(65536*myArray[25])); // low-gamma (31 - 39.75Hz)
  necomimi[10] = (myArray[30]+(256*myArray[29])+(65536*myArray[28])); // mid-gamma (41 - 49.75Hz)
  necomimi[11] ++ ; // big packet count
//necomimi[12] = (myArray[35]+(256*myArray[36])); // RAW DATA
//necomimi[13] ++ ; // small packet count

  println();
  println();
  println(" Signal " + necomimi[0]
    + " Attention " + necomimi[1]
    + " Meditation " + necomimi[2]
    + " Delta " + necomimi[3]
    + " Theta " + necomimi[4]
    + " Low Alpha " + necomimi[5]
    + " High Alpha " + necomimi[6]
    + " Low Beta " + necomimi[7]
    + " High Beta " + necomimi[8]
    + " Low Gamma " + necomimi[9]
    + " Mid Gamma " + necomimi[10]
    + " Packet Count " + necomimi[11]
    );
  println();
  
 // spit out values to second serial port
  if (serialOutput == 1){
  serial1.write (255) ;  // Begin Packet
  serial1.write (necomimi[0]) ;  // connectivity
  serial1.write (necomimi[1]) ;  // attention
  serial1.write (necomimi[2]) ;  // meditation
  serial1.write (necomimi[3]) ;  // Delta
  serial1.write (necomimi[4]) ;  // Theta
  serial1.write (necomimi[5]) ;  // Low Alpha
  serial1.write (necomimi[6]) ;  // High Alpha
  serial1.write (necomimi[7]) ;  // Low Beta
  serial1.write (necomimi[8]) ;  // High Beta
  serial1.write (necomimi[9]) ;  // Low Gamma
  serial1.write (necomimi[10]) ;  // High Gamma
      

      
}
  
  
}

//get the short RAW packet values (necomimi)
void necomimiRAW() {

  inByte = serial.read();
  inByte = serial.read();
  inByte = serial.read();
  myArray[36] = inByte; 
  inByte = serial.read();
  myArray[37] = inByte; 

  necomimi[12] = (myArray[37]+(256*myArray[36])); // RAW DATA
  if ( necomimi[12] >=  32768 ) {
    necomimi[12]=(necomimi[12]-65536);
  }
    
    necomimi[13] ++ ; // small packet count

  print(" RAW " + necomimi[12]  + " Packet Count " + necomimi[13] );
}
